
/******************************************************************************
* MODULE     : eval_args.cc
* DESCRIPTION: Evaluation of arguments
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::evaluate_arg (generic arg, keyword next) {
  // TRACE: (instr, ...)
  // INPUT: (caller, ...)
  cur= arg;
  rem= cons (next, rem);
  // OUTPUT: (arg, next, ...)
}

void
evaluator_rep::evaluate_args (list l, keyword next) {
  // TRACE: (instr, ...)
  // INPUT: (caller, ...)
  if (nil (l)) {
    cur= next;
    rem= cons (l, rem);
    // OUTPUT: (next, evaled_args, ...)
  }
  else {
    cur= car (l);
    rem= cons (KW_EVAL_ARGS_1, list(), cdr (l), next, rem);
    // OUTPUT: (first_arg, eval_args_1, (), other_args, next, ...)
  }
}

void
evaluator_rep::evaluate_args (keyword next) {
  // TRACE: (instr, ...)
  // INPUT: (caller, ...)
  list l= cdr (as_list (car (trace)));
  if (nil (l)) {
    cur= next;
    rem= cons (l, rem);
    // OUTPUT: (next, evaled_args, ...)
  }
  else {
    cur= car (l);
    rem= cons (KW_EVAL_ARGS_1, list(), cdr (l), next, rem);
    // OUTPUT: (first_arg, eval_args_1, (), other_args, next, ...)
  }
}

void
evaluator_rep::kw_eval_args_1 () {
  // Input: (eval_args_1, last_evaled, rev_done, todo, cont, ...)
  list rdone= cons (car (rem), as_list (cadr (rem)));
  list todo = as_list (caddr (rem));
  if (nil (todo)) {
    cur= cadddr (rem);
    rem= cons (reverse (rdone), cddddr (rem));
    // Output: (cont, done, ...)
  }
  else {
    cur= car (todo);
    rem= cons (KW_EVAL_ARGS_1, rdone, cdr (todo), cdddr (rem));
    // Output: (next_arg, eval_args_1, rev_done, todo, cont, ...)
  }
}

} // namespace mmx
