
/******************************************************************************
* MODULE     : glue_test.cc
* DESCRIPTION: glue for external libraries
* COPYRIGHT  : (C) 2003  Bernard Mourrain
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <glue.hh>

int
main (int argc, char** argv) 
{
  mmx::init();
  int i;
  mmx::string s;
  if (argc<2) { 
    cout<<argv[0]<<" file"<<std::endl;
    return 0;
  }

  for (i=1; i<argc; i++) {
    mmx::string arg (argv[i]);
    mmx::string name (arg);
    std::fstream  fout(as_charp(arg*".C"),std::ios::out);
  
    arg = arg *mmx::string(".mmx");
    mmx::insert_source (arg, "cmdline");
    cout << "Parsing " << arg << "\n";
    //    cout << hrule;
    if (load (arg, s)) cout << "Couldn't open file\n";
    else 
      {
	mmx::parse_string (s);
	mmx::list errors;
	mmx::generic output= mmx::parse (s, errors);
	//std::cout<<">>"<<output<<std::endl;
	mmx::print_errors (errors);
	cout << mmx::hrule;
	fout <<"#include <link.H>"<<std::endl;
	fout <<"#include <iostream>"<<std::endl;
	fout <<"#define MMX_Int    MMX_INT"<<std::endl;
	fout <<"#define ID_Int     ID_INT"<<std::endl;
	fout <<"#define MMX_String MMX_STRING"<<std::endl;
	fout <<"#define ID_String  ID_STRING"<<std::endl;
	fout <<"#define MMX_Void   MMX_VOID"<<std::endl;
	fout <<"#define ID_Void    ID_VOID"<<std::endl;
	mmx::generic preamble= mmx::car (mmx::cdr (mmx::car (mmx::cdr(output))));
	mmx::generic local = mmx::car(mmx::cdr(mmx::cdr(preamble)));
	preamble = mmx::car (mmx::cdr (preamble));
	cout<<preamble<<std::endl;
	cout<<local<<std::endl;
	cout << mmx::hrule;
	mmx::generate(fout,preamble);
	mmx::generate(fout,local);
	//cout << hrule;
	mmx::link(fout,local,name);
      }
    //    cout << hrule;
  }

  return 0;
}

