
/******************************************************************************
* MODULE     : table_test.cc
* DESCRIPTION: Test tables and symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <iostream>
#include <string.hh>
#include <symbol.hh>
#include <array.hh>
using namespace mmx;

int
main () {
  table t;
  cout << t << "\n";
  t (string ("Hallo")) = string ("Hop");
  cout << "ok\n";
  cout << t << "\n";
  t (string ("Walhalla")) = string ("Hop");
  cout << t << "\n";
  t (string ("Walhalla")) = string ("Hallo");
  cout << t << "\n";
  t (array (string ("Hallo"), string ("Ploef"))) = string ("Hola");
  t (list (string ("Boem"), string ("Ploef"))) = string ("Hum");
  cout << t << "\n";
  t->reset (string ("Hallo"));
  cout << t << "\n";
  cout << "----------------------------------------------------------------\n";
  symbol x (string ("x"));
  symbol y (string ("y"));
  symbol z (string ("z"));
  symbol x2 (string ("x"));
  cout << x << ", " << y << ", " << z << ", " << x2 << "\n";
  cout << "x = y ? " << (x==y) << "\n";
  cout << "x = x ? " << (x==x2) << "\n";
  return 0;
}
