
/******************************************************************************
* MODULE     : printer.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __PRINTER_HH
#define __PRINTER_HH
#include <list.hh>
namespace mmx {

class printer;
class printer_rep: generic_rep {
public:
  generic  name; // a descriptive name
  ostream& out;  // the ostream

protected:
  int Type ();
  int Hash ();
  bool Equal (generic g);
  generic Copy ();
  int Arity ();
  void Print (ostream& out);

public:
  inline printer_rep (generic name2, ostream& out2):
    name (name2), out (out2) {}

  friend class printer;
  friend printer copy (printer t);
  friend ostream& operator << (ostream& out, printer a);
};

class printer {
protected:
  printer_rep* rep;
  inline printer (printer_rep* rep2): rep (rep2) {}

public:
  inline printer (generic name, ostream& out):
    rep (new printer_rep (name, out)) {}
  inline friend printer as_printer (generic g) {
    if (gentype(g) != PRINTER_TYPE) type_mismatch (g, "printer");
    return printer ((printer_rep*) g.rep); }
  inline operator generic () { return generic (rep); }
  inline printer_rep* operator -> () { return rep; }

  inline bool operator == (printer out) {
    return ((&rep->out) == (&out->out)); }
  inline bool operator != (printer out) {
    return ((&rep->out) != (&out->out)); }
  friend printer copy (printer a);
  friend ostream& operator << (ostream& out, printer a);

  friend class printer_rep;
};

}
#endif // __PRINTER_HH
